/***********************************
 * 
 * Steroscopic Player v1.0 (2013.10.20 Relesed)
 * T. Kim (enoughrice21@yonsei.ac.kr) and J. Kang (jwkang@yonsei.ac.kr)
 *
 ***********************************/

#include "stdafx.h"
#include "StereoscopicPlayer.h"

#define MAX_LOADSTRING 100

const char* DIR_PATH = "C:\\MICSQ\\";

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_STEREOSCOPICPLAYER, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_STEREOSCOPICPLAYER));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;	//LoadIcon(hInstance, MAKEINTRESOURCE(IDI_STEREOSCOPICPLAYER));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+2);
	wcex.lpszMenuName	= NULL;	//MAKEINTRESOURCE(IDC_STEREOSCOPICPLAYER);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_POPUP | WS_MAXIMIZE,
      0, 0, 0, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   ShowWindow(hWnd, SW_MAXIMIZE);
   UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	static RECT m_iRect;
	FILE *fp;
	int iBuffer; char sBuffer1[50], sBuffer2[50];
	HANDLE hThread1, hThread2;
	char cKey;
	char path[100];


	switch (message)
	{
	case WM_CREATE:
		hWndAVILeft = MCIWndCreate(hWnd, hInst, MCIWNDF_NOMENU | MCIWNDF_NOPLAYBAR, NULL);
		hWndAVIRight = MCIWndCreate(hWnd, hInst, MCIWNDF_NOMENU | MCIWNDF_NOPLAYBAR, NULL);
		strcpy(path, DIR_PATH);
		strcat(path, "setup.txt");
		fp = fopen(path, "r");
		fscanf(fp, "%d", &iBuffer);
		fscanf(fp, "%f", &iBuffer);
		fscanf(fp, "%d", &iTotalVideo);
		fclose(fp);
		iCurrentVideo = 1;
		break;
	case WM_CHAR:
		cKey = (TCHAR)wParam;
		switch (cKey) {
			case 'n': case 'N':
				MCIWndStop(hWndAVILeft);
				MCIWndStop(hWndAVIRight);
				MCIWndClose(hWndAVILeft);
				MCIWndClose(hWndAVIRight);
				iCurrentVideo++;
				if (iCurrentVideo > iTotalVideo) {
					MCIWndDestroy(hWndAVILeft);
					MCIWndDestroy(hWndAVIRight);
					MessageBox(hWnd, "The assessment is Finished.", "Success", MB_OK);
					exit(0);
				}
			case 'o': case 'O':
				sprintf(sBuffer1, "%sVideo\\%d_L.wmv", DIR_PATH, iCurrentVideo);
				sprintf(sBuffer2, "%sVideo\\%d_R.wmv", DIR_PATH, iCurrentVideo);
				MCIWndOpen(hWndAVILeft, sBuffer1, NULL);
				MCIWndOpen(hWndAVIRight, sBuffer2, NULL);
				SetWindowPos(hWndAVILeft, NULL, 0, 0, m_iRect.right/2, m_iRect.bottom, SWP_SHOWWINDOW);
				SetWindowPos(hWndAVIRight, NULL, m_iRect.right/2, 0, m_iRect.right/2, m_iRect.bottom, SWP_SHOWWINDOW);
				break;
			
			case 'r': case 'R':
				MCIWndStop(hWndAVILeft);
				MCIWndStop(hWndAVIRight);
				MCIWndSeek(hWndAVILeft, MCIWND_START);
				MCIWndSeek(hWndAVIRight, MCIWND_START);
				break;

			case 's': case 'S':
				MCIWndStop(hWndAVILeft);
				MCIWndStop(hWndAVIRight);
				break;

			case 'p': case 'P':
				hThread1 = (HANDLE)_beginthreadex(NULL, 0, PlayFunc1,NULL, 0, NULL);
				hThread2 = (HANDLE)_beginthreadex(NULL, 0, PlayFunc2,NULL, 0, NULL);
				MCIWndSetVolume(hWndAVILeft, 0);
				MCIWndSetVolume(hWndAVIRight, 0);
				break;
		}
		break;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case WM_SIZE:
		GetClientRect(hWnd, &m_iRect);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}


unsigned WINAPI PlayFunc1(void *arg) {
	MCIWndPlay(hWndAVILeft);
	return 0;
}

unsigned WINAPI PlayFunc2(void *arg) {
	MCIWndPlay(hWndAVIRight);
	return 0;
}